{--------------------------------------------------------------}
{ Delphi interface to the FFTW Version 3.X "Single" library.   }
{ June 9, 2011                                                 }
{ Modified by Serdar S. Kacar                                  }
{ See original file comments below.                            }
{--------------------------------------------------------------}

{--------------------------------------------------------------}
{ Delphi interface to the FFTW library -- FFTW Version 3.0.1.  }
{ Note that this interface is incomplete. Additional function  }
{ interface entries may be added in an anologous manner, see   }
{ fftw  for more details.                  }
{                                                              }
{ Last modified 22/DEC/03                                      }
{ Written by Mark G. Beckett (g.beckett@epcc.ed.ac.uk          }
{--------------------------------------------------------------}

unit fftwf_;

interface

uses fftwgen;

const
  fftwf_dllpath = 'libfftw3f-3.dll';

type
  fftwf_plan = Pointer;
  Tfftwf_real_core = Single;
  Pfftwf_real = ^Tfftwf_real;
  Tfftwf_real = packed record // for fftwl_ compatibility
    v: Tfftwf_real_core;
  end;
  Pfftwf_complex = ^Tfftwf_complex;
  Tfftwf_complex = packed array[0..1] of Tfftwf_real;
  // alternative Tfftwf_complex type definition :
  //Tfftwf_complex = packed record
  //  re,im: Tfftwf_real;
  //end;

  Pfftwf_real_array = ^Tfftwf_real_array;
  Tfftwf_real_array = array[0..($7FFFFFFF div sizeof(Tfftwf_real))-1] of Tfftwf_real;
  Pfftwf_complex_array = ^Tfftwf_complex_array;
  Tfftwf_complex_array = array[0..($7FFFFFFF div sizeof(Tfftwf_complex))-1] of Tfftwf_complex;

function fftwf_malloc(n: Integer): Pointer; cdecl;
procedure fftwf_free(p: Pointer); cdecl;

function fftwf_init_threads(): Integer; cdecl;
procedure fftwf_plan_with_nthreads(nthreads: Integer); cdecl;
procedure fftwf_cleanup_threads(); cdecl;

function fftwf_import_system_wisdom(): Integer; cdecl;  // see "fftwf-wisdom.exe --help"
procedure fftwf_forget_wisdom(); cdecl;
// Delphi wisdom helper functions :
function fftwf_wisdom_export_AsAnsiString(): AnsiString;
function fftwf_wisdom_import_AsAnsiString(const AWisdomStr: AnsiString): Integer;

procedure fftwf_destroy_plan(plan: fftwf_plan); cdecl;
procedure fftwf_execute(plan: fftwf_plan); cdecl;
procedure fftwf_execute_dft(plan: fftwf_plan;
  inData, outData: Pfftwf_complex); cdecl;
procedure fftwf_execute_split_dft(plan: fftwf_plan;
  ri, ii, ro, io: Pfftwf_real); cdecl;
procedure fftwf_execute_dft_r2c(plan: fftwf_plan;
  inData: Pfftwf_real; outData: Pfftwf_complex); cdecl;
procedure fftwf_execute_split_dft_r2c(plan: fftwf_plan;
  inData, ro, io: Pfftwf_real); cdecl;
procedure fftwf_execute_dft_c2r(plan: fftwf_plan;
  inData: Pfftwf_complex; outData: Pfftwf_real); cdecl;
procedure fftwf_execute_split_dft_c2r(plan: fftwf_plan;
  ri, ii, outData: Pfftwf_real); cdecl;
procedure fftwf_execute_r2r(plan: fftwf_plan;
  inData, outData: Pfftwf_real); cdecl;

function fftwf_plan_dft_1d(n: Integer;
  inData, outData: Pfftwf_complex;
  sign: Integer; flags: Longword): fftwf_plan; cdecl;
function fftwf_plan_dft_2d(n0, n1: Integer;
  inData, outData: Pfftwf_complex;
  sign: Integer; flags: Longword): fftwf_plan; cdecl;
function fftwf_plan_dft_3d(n0, n1, n2: Integer;
  inData, outData: Pfftwf_complex;
  sign: Integer; flags: Longword): fftwf_plan; cdecl;
function fftwf_plan_dft(rank: integer; const n: PInteger;
  inData, outData: Pfftwf_complex;
  sign: Integer; flags: Longword): fftwf_plan; cdecl;

function fftwf_plan_dft_r2c_1d(n: Integer;
  inData: Pfftwf_real; outData: Pfftwf_complex;
  flags: Longword): fftwf_plan; cdecl;
function fftwf_plan_dft_r2c_2d(n0, n1: Integer;
  inData: Pfftwf_real; outData: Pfftwf_complex;
  flags: Longword): fftwf_plan; cdecl;
function fftwf_plan_dft_r2c_3d(n0, n1, n2: Integer;
  inData: Pfftwf_real; outData: Pfftwf_complex;
  flags: Longword): fftwf_plan; cdecl;
function fftwf_plan_dft_r2c(rank: integer; const n: PInteger;
  inData: Pfftwf_real; outData: Pfftwf_complex;
  flags: Longword): fftwf_plan; cdecl;

function fftwf_plan_dft_c2r_1d(n: Integer;
  inData: Pfftwf_complex; outData: Pfftwf_real;
  flags: Longword): fftwf_plan; cdecl;
function fftwf_plan_dft_c2r_2d(n0, n1: Integer;
  inData: Pfftwf_complex; outData: Pfftwf_real;
  flags: Longword): fftwf_plan; cdecl;
function fftwf_plan_dft_c2r_3d(n0, n1, n2: Integer;
  inData: Pfftwf_complex; outData: Pfftwf_real;
  flags: Longword): fftwf_plan; cdecl;
function fftwf_plan_dft_c2r(rank: integer; const n: PInteger;
  inData: Pfftwf_complex; outData: Pfftwf_real;
  flags: Longword): fftwf_plan; cdecl;

function fftwf_plan_r2r_1d(n: Integer;
  inData, outData: Pfftwf_real;
  kind: TFFTW_r2r_kind; flags: Longword): fftwf_plan; cdecl;
function fftwf_plan_r2r_2d(n0, n1: Integer;
  inData, outData: Pfftwf_real;
  kind, kind1: TFFTW_r2r_kind; flags: Longword): fftwf_plan; cdecl;
function fftwf_plan_r2r_3d(n0, n1, n2: Integer;
  inData, outData: Pfftwf_real;
  kind0, kind1, kind3: TFFTW_r2r_kind; flags: Longword): fftwf_plan; cdecl;
function fftwf_plan_r2r(rank: integer; const n: PInteger;
  inData, outData: Pfftwf_real;
  const kind: PFFTW_r2r_kind; flags: Longword): fftwf_plan; cdecl;


implementation

function fftwf_malloc; external fftwf_dllpath;
procedure fftwf_free; external fftwf_dllpath;
function fftwf_init_threads; external fftwf_dllpath;
procedure fftwf_plan_with_nthreads; external fftwf_dllpath;
procedure fftwf_cleanup_threads; external fftwf_dllpath;
function fftwf_import_system_wisdom; external fftwf_dllpath;
procedure fftwf_forget_wisdom; external fftwf_dllpath;
procedure fftwf_destroy_plan; external fftwf_dllpath;
procedure fftwf_execute; external fftwf_dllpath;
procedure fftwf_execute_dft; external fftwf_dllpath;
procedure fftwf_execute_split_dft; external fftwf_dllpath;
procedure fftwf_execute_dft_r2c; external fftwf_dllpath;
procedure fftwf_execute_split_dft_r2c; external fftwf_dllpath;
procedure fftwf_execute_dft_c2r; external fftwf_dllpath;
procedure fftwf_execute_split_dft_c2r; external fftwf_dllpath;
procedure fftwf_execute_r2r; external fftwf_dllpath;
function fftwf_plan_dft_1d; external fftwf_dllpath;
function fftwf_plan_dft_2d; external fftwf_dllpath;
function fftwf_plan_dft_3d; external fftwf_dllpath;
function fftwf_plan_dft; external fftwf_dllpath;
function fftwf_plan_dft_r2c_1d; external fftwf_dllpath;
function fftwf_plan_dft_r2c_2d; external fftwf_dllpath;
function fftwf_plan_dft_r2c_3d; external fftwf_dllpath;
function fftwf_plan_dft_r2c; external fftwf_dllpath;
function fftwf_plan_dft_c2r_1d; external fftwf_dllpath;
function fftwf_plan_dft_c2r_2d; external fftwf_dllpath;
function fftwf_plan_dft_c2r_3d; external fftwf_dllpath;
function fftwf_plan_dft_c2r; external fftwf_dllpath;
function fftwf_plan_r2r_1d; external fftwf_dllpath;
function fftwf_plan_r2r_2d; external fftwf_dllpath;
function fftwf_plan_r2r_3d; external fftwf_dllpath;
function fftwf_plan_r2r; external fftwf_dllpath;

procedure fftwf_export_wisdom(WriteCharFn: Tfftwgen_wisdom_writechar; data: Pointer); cdecl; external fftwf_dllpath;
function fftwf_import_wisdom(ReadCharFn: Tfftwgen_wisdom_readchar; data: Pointer): Integer; cdecl; external fftwf_dllpath;
function fftwf_wisdom_export_AsAnsiString(): AnsiString;
begin
  Result := fftwgen_wisdom_export_AsAnsiString(@fftwf_export_wisdom);
end;
function fftwf_wisdom_import_AsAnsiString(const AWisdomStr: AnsiString): Integer;
begin
  Result := fftwgen_wisdom_import_AsAnsiString(@fftwf_import_wisdom, AWisdomStr);
end;

end.














