{--------------------------------------------------------------}
{ Delphi interface to the FFTW Version 3.X "LongDouble" library}
{ June 9, 2011                                                 }
{ Modified by Serdar S. Kacar                                  }
{ See original file comments below.                            }
{--------------------------------------------------------------}

{--------------------------------------------------------------}
{ Delphi interface to the FFTW library -- FFTW Version 3.0.1.  }
{ Note that this interface is incomplete. Additional function  }
{ interface entries may be added in an anologous manner, see   }
{ fftw  for more details.                  }
{                                                              }
{ Last modified 22/DEC/03                                      }
{ Written by Mark G. Beckett (g.beckett@epcc.ed.ac.uk          }
{--------------------------------------------------------------}

unit fftwl_;

interface

uses fftwgen;

const
  fftwl_dllpath = 'libfftw3l-3.dll';

type
  fftwl_plan = Pointer;
  Tfftwl_real_core = Extended;
  Pfftwl_real = ^Tfftwl_real;
  Tfftwl_real = packed record // for fftwl_, sizeof(long double) should be 12.
    v: Tfftwl_real_core;
    dummy1: Word;
  end;
  Pfftwl_complex = ^Tfftwl_complex;
  Tfftwl_complex = packed array[0..1] of Tfftwl_real;
  // alternative Tfftwl_complex type definition :
  //Tfftwl_complex = packed record
  //  re,im: Tfftwl_real;
  //end;

  Pfftwl_real_array = ^Tfftwl_real_array;
  Tfftwl_real_array = array[0..($7FFFFFFF div sizeof(Tfftwl_real))-1] of Tfftwl_real;
  Pfftwl_complex_array = ^Tfftwl_complex_array;
  Tfftwl_complex_array = array[0..($7FFFFFFF div sizeof(Tfftwl_complex))-1] of Tfftwl_complex;

function fftwl_malloc(n: Integer): Pointer; cdecl;
procedure fftwl_free(p: Pointer); cdecl;

function fftwl_init_threads(): Integer; cdecl;
procedure fftwl_plan_with_nthreads(nthreads: Integer); cdecl;
procedure fftwl_cleanup_threads(); cdecl;

function fftwl_import_system_wisdom(): Integer; cdecl;  // see "fftwf-wisdom.exe --help"
procedure fftwl_forget_wisdom(); cdecl;
// Delphi wisdom helper functions :
function fftwl_wisdom_export_AsAnsiString(): AnsiString;
function fftwl_wisdom_import_AsAnsiString(const AWisdomStr: AnsiString): Integer;

procedure fftwl_destroy_plan(plan: fftwl_plan); cdecl;
procedure fftwl_execute(plan: fftwl_plan); cdecl;
procedure fftwl_execute_dft(plan: fftwl_plan;
  inData, outData: Pfftwl_complex); cdecl;
procedure fftwl_execute_split_dft(plan: fftwl_plan;
  ri, ii, ro, io: Pfftwl_real); cdecl;
procedure fftwl_execute_dft_r2c(plan: fftwl_plan;
  inData: Pfftwl_real; outData: Pfftwl_complex); cdecl;
procedure fftwl_execute_split_dft_r2c(plan: fftwl_plan;
  inData, ro, io: Pfftwl_real); cdecl;
procedure fftwl_execute_dft_c2r(plan: fftwl_plan;
  inData: Pfftwl_complex; outData: Pfftwl_real); cdecl;
procedure fftwl_execute_split_dft_c2r(plan: fftwl_plan;
  ri, ii, outData: Pfftwl_real); cdecl;
procedure fftwl_execute_r2r(plan: fftwl_plan;
  inData, outData: Pfftwl_real); cdecl;

function fftwl_plan_dft_1d(n: Integer;
  inData, outData: Pfftwl_complex;
  sign: Integer; flags: Longword): fftwl_plan; cdecl;
function fftwl_plan_dft_2d(n0, n1: Integer;
  inData, outData: Pfftwl_complex;
  sign: Integer; flags: Longword): fftwl_plan; cdecl;
function fftwl_plan_dft_3d(n0, n1, n2: Integer;
  inData, outData: Pfftwl_complex;
  sign: Integer; flags: Longword): fftwl_plan; cdecl;
function fftwl_plan_dft(rank: integer; const n: PInteger;
  inData, outData: Pfftwl_complex;
  sign: Integer; flags: Longword): fftwl_plan; cdecl;

function fftwl_plan_dft_r2c_1d(n: Integer;
  inData: Pfftwl_real; outData: Pfftwl_complex;
  flags: Longword): fftwl_plan; cdecl;
function fftwl_plan_dft_r2c_2d(n0, n1: Integer;
  inData: Pfftwl_real; outData: Pfftwl_complex;
  flags: Longword): fftwl_plan; cdecl;
function fftwl_plan_dft_r2c_3d(n0, n1, n2: Integer;
  inData: Pfftwl_real; outData: Pfftwl_complex;
  flags: Longword): fftwl_plan; cdecl;
function fftwl_plan_dft_r2c(rank: integer; const n: PInteger;
  inData: Pfftwl_real; outData: Pfftwl_complex;
  flags: Longword): fftwl_plan; cdecl;

function fftwl_plan_dft_c2r_1d(n: Integer;
  inData: Pfftwl_complex; outData: Pfftwl_real;
  flags: Longword): fftwl_plan; cdecl;
function fftwl_plan_dft_c2r_2d(n0, n1: Integer;
  inData: Pfftwl_complex; outData: Pfftwl_real;
  flags: Longword): fftwl_plan; cdecl;
function fftwl_plan_dft_c2r_3d(n0, n1, n2: Integer;
  inData: Pfftwl_complex; outData: Pfftwl_real;
  flags: Longword): fftwl_plan; cdecl;
function fftwl_plan_dft_c2r(rank: integer; const n: PInteger;
  inData: Pfftwl_complex; outData: Pfftwl_real;
  flags: Longword): fftwl_plan; cdecl;

function fftwl_plan_r2r_1d(n: Integer;
  inData, outData: Pfftwl_real;
  kind: TFFTW_r2r_kind; flags: Longword): fftwl_plan; cdecl;
function fftwl_plan_r2r_2d(n0, n1: Integer;
  inData, outData: Pfftwl_real;
  kind, kind1: TFFTW_r2r_kind; flags: Longword): fftwl_plan; cdecl;
function fftwl_plan_r2r_3d(n0, n1, n2: Integer;
  inData, outData: Pfftwl_real;
  kind0, kind1, kind3: TFFTW_r2r_kind; flags: Longword): fftwl_plan; cdecl;
function fftwl_plan_r2r(rank: integer; const n: PInteger;
  inData, outData: Pfftwl_real;
  const kind: PFFTW_r2r_kind; flags: Longword): fftwl_plan; cdecl;


implementation

function fftwl_malloc; external fftwl_dllpath;
procedure fftwl_free; external fftwl_dllpath;
function fftwl_init_threads; external fftwl_dllpath;
procedure fftwl_plan_with_nthreads; external fftwl_dllpath;
procedure fftwl_cleanup_threads; external fftwl_dllpath;
function fftwl_import_system_wisdom; external fftwl_dllpath;
procedure fftwl_forget_wisdom; external fftwl_dllpath;
procedure fftwl_destroy_plan; external fftwl_dllpath;
procedure fftwl_execute; external fftwl_dllpath;
procedure fftwl_execute_dft; external fftwl_dllpath;
procedure fftwl_execute_split_dft; external fftwl_dllpath;
procedure fftwl_execute_dft_r2c; external fftwl_dllpath;
procedure fftwl_execute_split_dft_r2c; external fftwl_dllpath;
procedure fftwl_execute_dft_c2r; external fftwl_dllpath;
procedure fftwl_execute_split_dft_c2r; external fftwl_dllpath;
procedure fftwl_execute_r2r; external fftwl_dllpath;
function fftwl_plan_dft_1d; external fftwl_dllpath;
function fftwl_plan_dft_2d; external fftwl_dllpath;
function fftwl_plan_dft_3d; external fftwl_dllpath;
function fftwl_plan_dft; external fftwl_dllpath;
function fftwl_plan_dft_r2c_1d; external fftwl_dllpath;
function fftwl_plan_dft_r2c_2d; external fftwl_dllpath;
function fftwl_plan_dft_r2c_3d; external fftwl_dllpath;
function fftwl_plan_dft_r2c; external fftwl_dllpath;
function fftwl_plan_dft_c2r_1d; external fftwl_dllpath;
function fftwl_plan_dft_c2r_2d; external fftwl_dllpath;
function fftwl_plan_dft_c2r_3d; external fftwl_dllpath;
function fftwl_plan_dft_c2r; external fftwl_dllpath;
function fftwl_plan_r2r_1d; external fftwl_dllpath;
function fftwl_plan_r2r_2d; external fftwl_dllpath;
function fftwl_plan_r2r_3d; external fftwl_dllpath;
function fftwl_plan_r2r; external fftwl_dllpath;

procedure fftwl_export_wisdom(WriteCharFn: Tfftwgen_wisdom_writechar; data: Pointer); cdecl; external fftwl_dllpath;
function fftwl_import_wisdom(ReadCharFn: Tfftwgen_wisdom_readchar; data: Pointer): Integer; cdecl; external fftwl_dllpath;
function fftwl_wisdom_export_AsAnsiString(): AnsiString;
begin
  Result := fftwgen_wisdom_export_AsAnsiString(@fftwl_export_wisdom);
end;
function fftwl_wisdom_import_AsAnsiString(const AWisdomStr: AnsiString): Integer;
begin
  Result := fftwgen_wisdom_import_AsAnsiString(@fftwl_import_wisdom, AWisdomStr);
end;

end.














